/*----- PROTECTED REGION ID(SIKO_MA505.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: SIKO_MA505.cpp,v 1.1.1.1 2013-12-24 15:09:38 borghes Exp $";
//=============================================================================
//
// file :        SIKO_MA505.cpp
//
// description : C++ source for the SIKO_MA505 and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               SIKO_MA505 are implemented in this file.
//
// project :     SIKO MA505 Magnetic Encoder Display.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 15:09:38 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/sikoma505/src/SIKO_MA505.cpp,v $
// $Log: SIKO_MA505.cpp,v $
// Revision 1.1.1.1  2013-12-24 15:09:38  borghes
// SIKO MA505 encoder display
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <SIKO_MA505.h>
#include <SIKO_MA505Class.h>

/*----- PROTECTED REGION END -----*/


/**
 *	SIKO_MA505 class description:
 *	SIKO MA505 Magnetic Encoder Display, SIKONETZ3 RS485.
 *	
 */

//================================================================
//
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//----------------------------------------------------------------
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

namespace SIKO_MA505_ns
{
	/*----- PROTECTED REGION ID(SIKO_MA505::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::namespace_starting



//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::SIKO_MA505()
 *	Description : Constructors for a Tango device
 *	              implementing the class SIKO_MA505
 */
//--------------------------------------------------------
SIKO_MA505::SIKO_MA505(Tango::DeviceClass *cl, string &s)
 	: Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(SIKO_MA505::constructor_1) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::constructor_1
}
//--------------------------------------------------------
SIKO_MA505::SIKO_MA505(Tango::DeviceClass *cl, const char *s)
 	: Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(SIKO_MA505::constructor_2) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::constructor_2
}
//--------------------------------------------------------
SIKO_MA505::SIKO_MA505(Tango::DeviceClass *cl, const char *s, const char *d)
 	: Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(SIKO_MA505::constructor_3) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::constructor_3
}


//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::delete_device()()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void SIKO_MA505::delete_device()
{
	/*----- PROTECTED REGION ID(SIKO_MA505::delete_device) ENABLED START -----*/

	//	Delete device allocated objects

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::delete_device
	delete[] attr_Position_read;
	
}


//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::init_device()
 *	Description : //	will be called at device initialization.
 */
//--------------------------------------------------------
void SIKO_MA505::init_device()
{
	DEBUG_STREAM << "SIKO_MA505::init_device() create device " << device_name << endl;

	/*----- PROTECTED REGION ID(SIKO_MA505::init_device_before) ENABLED START -----*/

	//	Initialization before get_device_property() call
	serial_device = NULL;

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::init_device_before
	
	//	Get the device properties (if any) from database
	get_device_property();
	
	attr_Position_read = new Tango::DevDouble[1];
	
	/*----- PROTECTED REGION ID(SIKO_MA505::init_device) ENABLED START -----*/

	//	Initialize device
	get_serial_connection();

	/*
	try {
		resolution = write_read(READ_RESOL_CMD);
	} catch (...) {
		resolution = 1;
	}
	*/
	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::init_device
}



//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void SIKO_MA505::get_device_property()
{
	/*----- PROTECTED REGION ID(SIKO_MA505::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("Serial_devicename"));
	dev_prop.push_back(Tango::DbDatum("Address"));
	dev_prop.push_back(Tango::DbDatum("Resolution"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on SIKO_MA505Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		SIKO_MA505Class	*ds_class =
			(static_cast<SIKO_MA505Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize Serial_devicename from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serial_devicename;
		else {
			//	Try to initialize Serial_devicename from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serial_devicename;
		}
		//	And try to extract Serial_devicename value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serial_devicename;

		//	Try to initialize Address from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  address;
		else {
			//	Try to initialize Address from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  address;
		}
		//	And try to extract Address value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  address;

		//	Try to initialize Resolution from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  resolution;
		else {
			//	Try to initialize Resolution from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  resolution;
		}
		//	And try to extract Resolution value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  resolution;


	}
	/*----- PROTECTED REGION ID(SIKO_MA505::get_device_property_after) ENABLED START -----*/

	//	Check device property data members init

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::get_device_property_after

}


//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void SIKO_MA505::always_executed_hook()
{
	INFO_STREAM << "SIKO_MA505::always_executed_hook()  " << device_name << endl;
	
	/*----- PROTECTED REGION ID(SIKO_MA505::always_executed_hook) ENABLED START -----*/

	//	code always executed before all requests

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::always_executed_hook
}




//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::read_attr_hardware()
 *	Description : Hardware acquisition for attributes.
 */
//--------------------------------------------------------
void SIKO_MA505::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "SIKO_MA505::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(SIKO_MA505::read_attr_hardware) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::read_attr_hardware

}


//--------------------------------------------------------
/**
 *	Read Position attribute
 *	Description: Readout position value
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void SIKO_MA505::read_Position(Tango::Attribute &attr)
{
	DEBUG_STREAM << "SIKO_MA505::read_Position(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(SIKO_MA505::read_Position) ENABLED START -----*/

	short pos_val = write_read(READ_POS_CMD);
	double factor = 1;
	for (int i= 0; i < resolution; i++) {
		factor = factor * 10;
	}
	(*attr_Position_read) = pos_val / factor;
	//	Set the attribute value
	attr.set_value(attr_Position_read);

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::read_Position
}


//--------------------------------------------------------
/**
 *	Method      : SIKO_MA505::SIKO_MA505Class::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *	              for specified device.
 */
//--------------------------------------------------------
void SIKO_MA505::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(SIKO_MA505::Class::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::Class::add_dynamic_attributes

}



//========================================================
//	Command execution methods
//========================================================


	/*----- PROTECTED REGION ID(SIKO_MA505::namespace_ending) ENABLED START -----*/

	//	Additional Methods
void SIKO_MA505::close_connection(Tango::DeviceProxy *devproxy_in)
{
	delete devproxy_in;
	devproxy_in = NULL;
}

bool SIKO_MA505::check_connection(Tango::DeviceProxy *devproxy_in)
{
	if (devproxy_in == NULL)
		return false;

	try
	{
		devproxy_in->ping();
		set_state(Tango::ON);
		set_status("The device is in ON state.");
		return true;
	}
	catch(...)
	{
		set_state(Tango::FAULT);
		set_status("Serial device not responding.");
		return false;
	}
}

bool SIKO_MA505::get_serial_connection()
{
	// if we already have a serial device instance, do nothing
	if (check_connection(serial_device))
		return true;

	// otherwise, try to (re)connect
	try
	{
		// connect
		serial_device = new Tango::DeviceProxy(serial_devicename.c_str());

		// if we could not connect, notify caller
		if (!check_connection(serial_device))
			return false;

		// everything is ok
		return true;
	}
	catch(...)
	{
		// if anything goes wrong, free the serial device and return false
		close_connection(serial_device);

		return false;
	}
}

short SIKO_MA505::write_read(int cmd_id)
{
  	char buffer[7];
	int ncharout,ncharin;
	char ceck_code;
	short val = 0;

	if (!get_serial_connection()) {
	    	Tango::Except::throw_exception(
			   (const char *)"SIKO_MA505",
			   (const char *)"Serial device communication ERROR",
			   (const char *)"SIKO_MA505::write_read");
	}

	switch (cmd_id) {
		case READ_POS_CMD:
			buffer[0]=128 + address; // 128 means that we need a response
			buffer[1]=READ_POS_CMD;
			buffer[2]=(buffer[0]^buffer[1]);
			buffer[3]=0;
			ncharout = 3;
			ncharin = 6;
			break;
		case READ_RESOL_CMD:
			buffer[0]=128 + address; // 128 means that we need a response
			buffer[1]=READ_RESOL_CMD;
			buffer[2]=(buffer[0]^buffer[1]);
			buffer[3]=0;
			ncharout = 3;
			ncharin = 6;
			break;
		default:
			return -1;

	}
	Tango::DeviceData argin,argin_flush;
	Tango::DevVarCharArray vcharr;

	vcharr.length(ncharout);
	for(int i=0;i<ncharout;i++) {
		vcharr[i] = buffer[i];
	}
	argin << vcharr;
	argin_flush << (Tango::DevLong)2;
	try{
		serial_device->command_inout("DevSerFlush",argin_flush);
		serial_device->command_inout("DevSerWriteChar",argin);
	}
	catch (CORBA::Exception &e)
        {
		set_state(Tango::FAULT);
		set_status("MA505 not responding, check device address.");
	    	Tango::Except::throw_exception(
			   (const char *)"SIKO_MA505",
			   (const char *)"Serial device communication error",
			   (const char *)"SIKO_MA505::write_read");
        }
        catch (...)
        {
		set_state(Tango::FAULT);
		set_status("MA505 not responding, check device address.");
	    	Tango::Except::throw_exception(
			   (const char *)"SIKO_MA505",
			   (const char *)"Serial device communication error",
			   (const char *)"SIKO_MA505::write_read");
        }


	
	usleep(40000);

	Tango::DeviceData argin_1;
	Tango::DeviceData argout;
	const Tango::DevVarCharArray *vcharr_resp;
	
	argin_1 << (Tango::DevLong)((ncharin << 8) | SL_NCHAR);
	try{
		argout = serial_device->command_inout("DevSerReadChar",argin_1);
	}
	catch (CORBA::Exception &e)
        {
		set_state(Tango::FAULT);
		set_status("MA505 not responding, check device address.");
	    	Tango::Except::throw_exception(
			   (const char *)"SIKO_MA505",
			   (const char *)"Serial device communication error",
			   (const char *)"SIKO_MA505::write_read");
        }
        catch (...)
        {
		set_state(Tango::FAULT);
		set_status("MA505 not responding, check device address.");
	    	Tango::Except::throw_exception(
			   (const char *)"SIKO_MA505",
			   (const char *)"Serial device communication error",
			   (const char *)"SIKO_MA505::write_read");
        }
	argout >> vcharr_resp;
	ceck_code = 0;
	for(int i=0;i < (vcharr_resp->length()-1);i++) {
		ceck_code = ceck_code ^ (*vcharr_resp)[i];
	}
	if ((*vcharr_resp)[(vcharr_resp->length()-1)] != ceck_code) {
		WARN_STREAM << "SIKO_MA505::write_read() unexpected check byte" << endl;
	}
        switch (cmd_id) {
		case READ_POS_CMD:
			if (vcharr_resp->length() < 6) {
	    			Tango::Except::throw_exception(
					   (const char *)"SIKO_MA505",
					   (const char *)"Serial response error",
					   (const char *)"SIKO_MA505::write_read");
			}
			val = (*vcharr_resp)[2] + (*vcharr_resp)[3]*256 + (*vcharr_resp)[4] *256 * 256;
			break;
		case READ_RESOL_CMD:
			if (vcharr_resp->length() < 6) {
	    			Tango::Except::throw_exception(
					   (const char *)"SIKO_MA505",
					   (const char *)"Serial response error",
					   (const char *)"SIKO_MA505::write_read");
			}
			val = (*vcharr_resp)[3];
			break;
	}
	return val;
}
	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::namespace_ending
} //	namespace
